#ifndef WALL_H
#define WALL_H
#include "Ball.h"
#include "CVector.h"
#include "PhysicsElement.h"

class Wall: public PhysicsElement {
private: 
   static int id;
   CVector a, b;  // extreme points of the wall. This allows 
                  // containers of any shape although it is not
                  // required in this assignment 

   Wall();    // nobody can create a Wall without state
public:
   Wall(CVector aPoint, CVector bPoint);
   const PhysicsElement * collideWith(const Ball * pb)const;
   CVector getAend() const {
      return a;
   }
   CVector getBend() const {
      return b;
   }
   virtual string getDescription()const;
   virtual string getState()const;
};
#endif